def cleanString(str,quote):
  clean_item = str
  if clean_item.find(quote) != -1:
    clean_item = clean_item[1:-1].replace('%s%s'%(quote,quote), quote)
  elif clean_item == '':
    clean_item = None
  return clean_item

def splitCsvLine(str_line,separator = ',',quote = '"'):
  unclean_list = []
  pieces_of_line = str_line.split(separator)
  
  p_stack = ''
  for p in pieces_of_line:
    if p_stack == '':
      p_stack = p
    else:
      p_stack += ',%s' % p
    if p_stack.count(quote) % 2 == 0:
      unclean_list.append(p_stack)
      p_stack = ''

  return [cleanString(x,quote) for x in unclean_list]

def findSeparator(analyze_list,separator_list):
  separator_dict = {}

  for separator in separator_list:
    last_num_of_split = 0
    separator_dict[separator] = 1
    for analyze_line in analyze_list:
      num_of_split = len(analyze_line.split(separator))
      if last_num_of_split != 0:
        if num_of_split != last_num_of_split:
          separator_dict[separator] = 0
      last_num_of_split = num_of_split
    if last_num_of_split <= 1:
      separator_dict[separator] = 0

  for separator in separator_list:
    if separator_dict[separator] == 1:
      break

  if separator_dict[separator] == 0:
    # none applied
    separator = ','

  return separator

def findQuote(test_line,separator):
  quote = None
  for chunk in test_line.split(separator):
    if len(chunk)>0:
      if chunk[0] == '"':
        quote = '"'
      elif chunk[0] == "'":
        quote = "'"
    if quote is not None:
      break
  return quote


separator_list = [
  ',',
  ';',
  ':',
  '\t',
  ' ',
]

test_file_list = [
  'test_data_dblq_semicolon.csv',
  'test_data_dblq_comma.csv',
  'test_data_dblq_tab.csv',
  'test_data_sgnq_semicolon.csv',
  'test_data_sgnq_comma.csv',
  'test_data_sgnq_tab.csv',

]

test_dict = {}

for filename in test_file_list:
  f = file(filename,"r")
  data = [line.replace('\n','') for line in f.readlines()]
# 1 pass - we are getting max 10 lines of CVS -> analyze_list
# 2 pass - looking for separator from separatol list,
# 2.a for each separator in separator list:
# 2.b split analyze list using separator
# 2.c if every analyze line has same no of splitted 

  analyze_list = data[:10]

# 3. now we have to choose first good separator
#    , ; : \t ' '

  separator = findSeparator(analyze_list,separator_list)

# 4. now we need to find which is quote - is it ' or "?

  test_line = analyze_list[-1]
  quote = findQuote(test_line,separator)

  test_dict[filename] = []
  for line in data:
    test_dict[filename].append(splitCsvLine(line,separator,quote))

first_set = test_dict[test_file_list[0]]

for filename in test_file_list:
  line_num = 0
  for line in test_dict[filename]:
    if line != first_set[line_num]:
      print 'Reference = %s'%(first_set[line_num])
      print '%s = %s'%(filename,test_dict[filename])
    line_num = line_num + 1
